<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="20" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
      <el-row :gutter="20">
        <!-- BUSCADOR --> 
        <el-col :span="6" :offset="18">
          <app-search-filter v-model="textSearch"></app-search-filter>
        </el-col>  
      </el-row>
    </header>

   <!-- COMPONENTE TITULO MATERIALES NACIONALES -->
    <div style="margin:3rem 6rem">
      <app-title :Title="'MATERIALES NACIONALES - '+ typeContentSupport.toUpperCase()"> </app-title>
    </div>

    <!-- Leyenda -->
    <div style="margin:3rem 6rem">
      <el-row>
        <el-col :span="22" :offset="1">
          <h5 style="margin: 2rem 0"> ESTADO DE LOS MATERIALES </h5>
        </el-col>
      </el-row>
      <DescriptionStateOrders v-if="typeContentSupport == 'Largometrajes' || typeContentSupport == 'Miniseries'"
                              :TextSquareBlue="''" :TextSquareOrange="''" :TextSquareGray="'Pendiente'" :TextSquarePurple="''"
                              :TextSquareRed="''" :TextSquareGreen="'Recibido'" :colBoxes="5"> 
      </DescriptionStateOrders>
      <DescriptionStateOrders v-else-if="typeContentSupport == 'Novelas' || typeContentSupport == 'Series' || typeContentSupport == 'Dibujos'"
                              :TextSquareBlue="''" :TextSquareOrange="''" :TextSquareGray="'No se ha ingresado ningún capítulo'" :TextSquarePurple="''"
                              :TextSquareRed="'Capítulos incompletos'" :TextSquareGreen="'Capítulos completos'"> 
      </DescriptionStateOrders>
      <el-row type="flex" justify="space-between" v-else>
        <el-col :span="24">
          <el-row>
            <el-col :span="11" :offset="1">
              <h4 style="margin-bottom: 10px">{{typeContentSupport.toUpperCase()}} SIN CAPÍTULOS</h4>
              <div style="margin: 8px 0" v-for="(item, index) in withoutCaps" :key="index">
                <div class="flex element-bloq-center" > 
                  <div :class="item.style" class="border-radius-light" style="margin-right:1rem; height:25px; width:25px"></div> 
                  <span>{{item.name}}</span>
                </div>
              </div>
            </el-col>
            <el-col :span="10" :offset="2">
              <h4 style="margin-bottom: 10px">{{typeContentSupport.toUpperCase()}} CON CAPÍTULOS</h4>
              <div style="margin: 8px 0" v-for="(item, index) in withCaps" :key="index">
                <div class="flex element-bloq-center" > 
                  <div :class="item.style" class="border-radius-light" style="margin-right:1rem; height:25px; width:25px"></div> 
                  <span>{{item.name}}</span>
                </div>
              </div>
            </el-col>
          </el-row>
        </el-col>
      </el-row>
    </div>

    <!--COMPONENTE CARDS -->
    <div style="margin:3rem 6rem">
      <el-row :gutter="80">
        <el-col :span="12" v-for="(item, index) in materials.slice(0,30)" :key="index" style="margin-bottom: 3rem"> 
          <CardSuport v-if="item.numChapters.length > 0" :stateOrder="item.stateBtnSupport" :numberOrder="' '" :originalTitle="item.listTitle"
                      :colorButton="item.colorBtnSupport" :codMaterial="item.codMaterial" :titleToShow="'Temporada'" :dataToShow="(item.numChapters.map(i => i.season)).join(' - ')"
                      @eventEmit="changeRoute(item.__id, item, index, 'new')">        
          </CardSuport>
          <CardSuport v-else :stateOrder="(item.stateBtnSupport).toUpperCase()" :numberOrder="' '" :originalTitle="item.listTitle" 
                       :colorButton="item.colorBtnSupport" :codMaterial="item.codMaterial" :titleToShow="'Fecha de llegada'" :dataToShow="(item.supportObj)?new Date(item.supportObj.arrivalDate).toLocaleDateString('en-GB'): ''"
                       @eventEmit="redirectButton(item.__id, item, 'new')">        
          </CardSuport>
        </el-col>
      </el-row>
    </div>
  </div>
</template>

<script>

import ReturnButton from '@/components/ReturnButton.vue'
import Title from '@/components/Title.vue'    
import SearchFilter from '@/components/searchFilter.vue'
import { modifyText } from '../../../utils/modifyText.js'
import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue' 
import CardSuport from '@/components/CardSuport.vue'
import { HTTP } from '../../../main.js' 


export default {
  components: {
    ReturnButton,
    CardSuport,
    'app-search-filter': SearchFilter, 
    'app-title': Title,
    DescriptionStateOrders,
  },

  data () {
    return {
      textSearch: '',
      typeMaterial: localStorage.getItem('typeMaterialR'), // tipo de material
      typeContentSupport: this.$localStorage.get('typeContentSupport'),// tipo de contenido
      getMat: [],
      withCaps: [
        {style: 'l-grey', name: 'No se ha ingresado ningún capítulo'},
        {style: 'bg-red', name: 'Capítulos Incompletos'},
        {style: 'l-green', name: 'Capítulos Completos'}
      ],
      withoutCaps: [
        {style: 'l-grey', name: 'Pendiente'},
        {style: 'l-green', name: 'Recibido'}
      ]
    };
  },
  created() {
    this.getMaterials(this.typeContentSupport, 'getMat')
  },
  computed: {
    materials () {
      let mShow = this.getMat
      if (this.textSearch) {
        mShow = mShow.filter(
          m => modifyText(m.originalTitle).indexOf(modifyText(this.textSearch)) > -1) ||
              modifyText(m.ownTitle).indexOf(modifyText(this.textSearch)) > -1 ||
              modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1 
      }
      return mShow
    }
  },
  methods: {
    changeRoute (id, item, index, text) {
      
      this.$localStorage.set('idSupportMat', JSON.stringify(id))
      sessionStorage.setItem('infoMatSelected', JSON.stringify( item ))

      if(item.stateBtnSupport !== 'COMPLETO') {
        this.$localStorage.set('edit', JSON.stringify(item.stateBtnSupport))
        this.$router.push({ name: 'receptionMaterialsNac' })
      }
      else {
        this.$localStorage.set('edit', JSON.stringify(text))
        this.$router.push({ name: 'formProductNac' })
      }
    },
    redirectButton (id, item, text) {
      
      
      this.$localStorage.set('idSupportMat', JSON.stringify(id))
      sessionStorage.setItem('infoMatSelected', JSON.stringify( item ))
      
      if(item.stateBtnSupport !== 'Recibido') {
        this.$router.push({ name: 'receptionNational' })
      }
      else {
        this.$router.push({ name: 'reportNational' })
      }
    },
    orderDataByGeminisCode (array) {
      array.sort(function (a, b) {
        if ( Number(a.geminisCode) < Number(b.geminisCode) ) {
          return 1;
        }
        if ( Number(a.geminisCode) > Number(b.geminisCode )) {
          return -1;
        }
        return 0;
      });
      return array
    },
    getMaterials (material, array) {
      HTTP.get('materials/materialType/'+this.typeMaterial+'/typeOfContent/'+material+'/canned/false')
      .then(res => {
        this[array] = this.orderDataByGeminisCode(res.data.materials)
      })
      .catch(err => {
        console.log(err);
      });
    },
    returnPage () {
      this.$router.push({ name: 'tipoDeMaterialNacional'})
    },
  }
}
</script>